Program FLI;
{ FLI Player by CIMEDIA}
{ Csar Vellido, 1997. }

label
  Exit;

Type
  tHeadFLI=RECORD
            longFile:longint;
            H_magic:word;
            frames,
            width,
            height,
            planes,
            speed:word;
            dummy:array[1..112]of byte;
          end;
  tHeadFrame=RECORD
              longframe:longint;
              F_magic:word;
              Blocks:word;
              dummy:array[1..8]of byte;
            end;
  tHeadBlock=RECORD
               longBlock:longint;
               BlockType:word;
             end;
  tHeadBlockTrozo=RECORD
                    y1,height:word;
                  end;
  tPalette=array[0..255,1..3]of byte;

var
  FLIfile:file;
  Palette:tPalette;
  HeadFLI:tHeadFLI;
  buffer,buffer2:pointer;
  frame:integer;
  TIMER:DWORD absolute $46C;
  LastTimer:DWORD;

Function EscPressed:boolean;
begin
  EscPressed:=Port[$60]=1;
end;

Procedure VGAMode(mode:byte);
assembler;
asm
  mov   ah,0
  mov   al,mode
  int   10h
end;

Procedure WaitRetrace;
begin
  repeat until (Port[$3DA] and 8)=0;
  repeat until (Port[$3DA] and 8)>0;
end;

Procedure InstallPalette;
var
  i:byte;
begin
  for i:=0 to 255 do
    begin
      Port[$3C8]:=i;
      Port[$3C9]:=Palette[i,1];
      Port[$3C9]:=Palette[i,2];
      Port[$3C9]:=Palette[i,3];
    end;
end;

Procedure ReadFrame;
var
  HeadFrame:tHeadFrame;
  HeadBlock:tHeadBlock;
  Block:word;
  x1,data2:byte;
  data:shortint;
  fnt,dst:^byte;

 Procedure Read(var dst;tamano:word);
 begin
   Move(fnt^,addr(dst)^,tamano);
   inc(fnt,tamano);
 end;

 Procedure FLI_COLOR;
 var
   cont,
   first,
   Size,
   b1:byte;
   packets:word;
   xx:word;

 begin
   Read(packets,2);
   first:=0;
   xx:=0;
   for cont:=1 to packets do
    begin
      Read(b1,1);       {colores a saltar}
      Read(Size,1);  {colores a cambiar}
      inc(xx,Size);  {contador de bytes cambiados}
      inc(first,b1);
      Read(Palette[first],(Size+256*ord(Size=0))*3);
      inc(first,Size);
    end;
   if (xx*3) mod 2>0 then Read(b1,1); {fuerza la paridad}
 end;

 Procedure FLI_LC;
 var
   BlockTrozo:tHeadBlockTrozo;
   numpackets,packet,line:byte;
 begin
   Read(BlockTrozo,SizeOf(tHeadBlockTrozo));
   for line:=0 to BlockTrozo.height-1 do
    begin
      Read(Numpackets,1);
      dst:=buffer2;
      inc(dst,(BlockTrozo.y1+line)*320);
      for packet:=1 to numpackets do
       begin
         Read(x1,1);
         inc(dst,x1);
         Read(data,1);
         if(data<0) then
          begin
            Read(data2,1);
            FillChar(dst^,-data,data2);
            inc(dst,-data);
          end
         else
          begin
            Read(dst^,data);
            Inc(dst,data);
          end;
       end;
    end;
 end;

 Procedure FLI_BLACK;
 begin
   FillChar(dst^,HeadFLI.width*HeadFLI.height,0);
 end;

 Procedure FLI_BRUN;
 var
   numpackets,
   packet,
   line:byte;
 begin
   for line:=0 to HeadFLI.height-1 do
    begin
      Read(Numpackets,1);
      for packet:=1 to numpackets do
       begin
         Read(data,1);
         if (data>0) then
          begin
            Read(data2,1);
            FillChar(dst^,data,data2);
            Inc(dst,data);
          end
         else
          begin
            data:=-data;
            Read(dst^,data);
            inc(dst,data);
          end;
       end;
    end;
 end;

 Procedure FLI_COPY;
 begin
   Read(dst^,HeadFLI.width*HeadFLI.height);
 end;

begin
  blockRead(FLIFile,HeadFrame,SizeOf(tHeadFrame));
  BlockRead(FLIFile,buffer^,HeadFrame.longframe-SizeOf(tHeadFrame));
  fnt:=buffer;
  for Block:=1 to HeadFrame.Blocks do
   begin
     dst:=buffer2;
     Read(HeadBlock,SizeOf(tHeadBlock));
     case (HeadBlock.BlockType) of
      11:FLI_COLOR;
      12:FLI_LC;
      13:FLI_BLACK;
      15:FLI_BRUN;
      16:FLI_COPY;
     end;
   end;
end;

BEGIN
  {$I-}
  if ParamCount<>1 then
   begin
    Writeln('Use FLI filename.FLI');
    Halt(1);
   end;
  Assign(FLIfile,ParamStr(1));
  Reset(FLIfile,1);
  If IOResult<>0 then
   begin
    Writeln('Error: ',ParamStr(1),' not found.');
    Halt(2);
   end;
  BlockRead(FLIfile,HeadFLI,SizeOf(tHeadFLI));
  If HeadFLI.H_magic<>$AF11 then
   begin
    Writeln('Error in '+Paramstr(1)+'.');
    halt(3);
   end;
  GetMem(buffer,64000);
  GetMem(buffer2,64000);
  VGAMode($13);
  LastTimer:=TIMER;
  repeat
   for frame:=1 to HeadFLI.frames do
    begin
      ReadFrame;
      repeat until TIMER>LastTimer+(HeadFLI.Speed shr 2);
      LastTimer:=TIMER;
      WaitRetrace;
      InstallPalette;
      Move(buffer2^,ptr($A0000)^,64000);
      if EscPressed then goto Exit;
    end;
    seek(FLIFile,SizeOf(tHeadFLI));
  until false;
 Exit:
  VGAMode($03);
  FreeMem(buffer2,64000);
  FreeMem(buffer,64000);
  close(FLIfile);
END.
